> ## Documentation Index
> Fetch the complete documentation index at: https://bulkgrid.com/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# Analyze a GitHub repository

> Required permission: sources:write.



## OpenAPI

````yaml /api-reference/openapi.json post /api/v1/index/sources/github/analyze
openapi: 3.0.3
info:
  title: Bulkgrid API
  version: 0.4.0
  description: >-
    Search the live web, manage and search indexed content under /index, create
    crawl and extraction runs, and retrieve results. API keys require the scopes
    listed for each operation. OAuth connections grant MCP and search access
    only.
servers:
  - url: https://bulkgrid.com
    description: Bulkgrid
security:
  - apiKeyAuth: []
  - bearerAuth: []
tags:
  - name: Sources
    description: Source discovery, subscriptions, and indexing
  - name: Collections
    description: Collections and content selection rules
  - name: Search
    description: Search endpoints
  - name: Index
    description: Search indexed workspace content
  - name: Runs
    description: Run creation and lifecycle endpoints
  - name: Results
    description: Run result retrieval endpoints
paths:
  /api/v1/index/sources/github/analyze:
    post:
      tags:
        - Sources
      summary: Analyze a GitHub repository
      description: 'Required permission: sources:write.'
      operationId: sourcesAnalyzeGithub
      parameters: []
      requestBody:
        required: true
        content:
          application/json:
            schema:
              type: object
              properties:
                connection_id:
                  type: string
                  format: uuid
                  pattern: >-
                    ^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$
                workspace_id:
                  type: string
                  format: uuid
                  pattern: >-
                    ^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$
                repositoryUrl:
                  type: string
                  format: uri
                ref:
                  type: string
                  minLength: 1
                  maxLength: 255
                suggestPaths:
                  type: boolean
              required:
                - repositoryUrl
      responses:
        '200':
          description: Successful response
          content:
            application/json:
              schema:
                type: object
                properties:
                  label:
                    type: string
                    minLength: 1
                    maxLength: 200
                  ref:
                    type: string
                    minLength: 1
                    maxLength: 255
                  includePaths:
                    maxItems: 100
                    type: array
                    items:
                      type: string
                      minLength: 1
                      maxLength: 1024
                  excludePaths:
                    maxItems: 100
                    type: array
                    items:
                      type: string
                      minLength: 1
                      maxLength: 1024
                  confidence:
                    type: number
                    minimum: 0
                    maximum: 1
                  notes:
                    nullable: true
                    type: string
                    minLength: 1
                    maxLength: 1000
                  fileCount:
                    type: integer
                    minimum: 0
                    maximum: 9007199254740991
                  defaultBranch:
                    type: string
                    minLength: 1
                  latestRelease:
                    oneOf:
                      - type: object
                        properties:
                          status:
                            type: string
                            enum:
                              - available
                          tag:
                            type: string
                            minLength: 1
                            maxLength: 255
                        required:
                          - status
                          - tag
                        additionalProperties: false
                      - type: object
                        properties:
                          status:
                            type: string
                            enum:
                              - none
                        required:
                          - status
                        additionalProperties: false
                      - type: object
                        properties:
                          status:
                            type: string
                            enum:
                              - unavailable
                        required:
                          - status
                        additionalProperties: false
                  files:
                    type: array
                    items:
                      type: string
                      minLength: 1
                required:
                  - label
                  - ref
                  - includePaths
                  - excludePaths
                  - confidence
                  - notes
                  - fileCount
                  - defaultBranch
                  - latestRelease
                  - files
                additionalProperties: false
        '400':
          description: Bad request
          content:
            application/json:
              schema:
                type: object
                properties:
                  error:
                    type: string
                  details: {}
                required:
                  - error
                additionalProperties: false
        '401':
          description: Unauthorized
          content:
            application/json:
              schema:
                type: object
                properties:
                  error:
                    type: string
                  details: {}
                required:
                  - error
                additionalProperties: false
        '403':
          description: Forbidden
          content:
            application/json:
              schema:
                type: object
                properties:
                  error:
                    type: string
                  details: {}
                required:
                  - error
                additionalProperties: false
        '404':
          description: Not found
          content:
            application/json:
              schema:
                type: object
                properties:
                  error:
                    type: string
                  details: {}
                required:
                  - error
                additionalProperties: false
        '429':
          description: Rate limited
          content:
            application/json:
              schema:
                type: object
                properties:
                  error:
                    type: string
                  details: {}
                required:
                  - error
                additionalProperties: false
        '500':
          description: Internal server error
          content:
            application/json:
              schema:
                type: object
                properties:
                  error:
                    type: string
                  details: {}
                required:
                  - error
                additionalProperties: false
      security:
        - apiKeyAuth: []
        - bearerAuth: []
components:
  securitySchemes:
    apiKeyAuth:
      type: apiKey
      in: header
      name: x-api-key
      description: Bulkgrid API key
    bearerAuth:
      type: http
      scheme: bearer
      description: >-
        Bulkgrid API key or OAuth access token. OAuth grants currently allow
        search:query and mcp:use only.

````

This documentation is built and hosted on [Mintlify](https://mintlify.com), a developer documentation platform.